#!/usr/bin/perl

die "Args: numero_puntos\n" if $#ARGV != 0;

# Otro programn para generar la estadstica
# de muestras de una variable aleatoria con una
# distribucin Gausiana
#
# Fraga, 4/08/2006
#
# En Cd. Victoria, en la Unidad Tamaulipas del Cinvestav

# la funcion gasdev()
# genera una muestra de una variable aleatoria con
# una distribucin normal. N(0,1)
#
my $iset=0;
sub gasdev
{
	my $v1;
	my $v2;
	my $r;
	if  ($iset == 0) {
		do {
			$v1=2.0*rand()-1.0;
			$v2=2.0*rand()-1.0;
			$r=$v1*$v1 + $v2*$v2;
		} while ($r >= 1.0);
		my $fac=sqrt(-2.0*log($r)/$r);
		$gset=$v1*$fac;
		$iset=1;
		return $v2*$fac;
	} 
	else {
		$iset=0;
		return $gset;
	}
} 

$sigma=20;
$mu=60;

$n=$ARGV[0];


# limpio el arreglo donde se guardar la estadstica
for($i=0; $i<=120; $i++) {
	$cuenta[$i] = 0;
}

#
# repito el "esperimento" $n veces
#
for($i=0; $i<$n; $i++) {
    $z = $mu + $sigma*gasdev();

	$k = int( $z + 0.5 );
	if ( $k>=0 && $k <= 120 ){
	    $cuenta[$k] ++;
	}
}

# Imprimimos el resultado y calculamos el promedio

$salida = "gausiana.txt";
open( ARCH, ">$salida" ) or die "No pude abrir archivo $salida\n";
for($i=0; $i<=120; $i++) {
	print ARCH "$i $cuenta[$i]\n";
}
close( ARCH ); 

# Calculamos la media y la desviacin estndar
$sum = 0;
$sum2 = 0;
for($i=1; $i<=120; $i++) {
	$v = $cuenta[$i];
	$sum += $i * $v;
	$sum2 += $i * $i * $v;
}

# La media
$sum /= $n;
$sum2 = $sum2/$n - $sum*$sum;
$sigma = sqrt($sum2);
print "Media y varianza:\n";
print "$sum $sigma\n";
